#include <stdio.h>
#include <stdlib.h>
#include "caminho.h"
#include "capacitores.h"
#include "decodificador.h"
#include "dicionario.h"
#include "LOG.h"

int decoder=0;
int main()
{
    //Criando ponteiros
    FILE* mapaCriptografado;
    FILE* mapaDescriptografado;
    FILE* config;
    FILE* bombaDesarmada;
    FILE* bomba;
    FILE* codigo;
    FILE* log;
    Lista* inicio = NULL;
    Dados robo; //Estrutura que guarda dados
    Dados* pRobo = &robo;
    //Abrindo os arquivos necessrios
    log = fopen ("LOG.TXT", "w");
    mapaCriptografado = fopen ("MAPAcriptografado.TXT", "r");
    mapaDescriptografado = fopen ("MAPAdescriptografado.TXT", "w");
    config = fopen ("CONFIG.TXT", "r");
    bombaDesarmada = fopen ("BOMBAdesarmada.TXT", "r");
    bomba = fopen ("BOMBA.TXT", "r");
    codigo = fopen ("codigo.TXT", "w");

    decodificador (config, mapaCriptografado, mapaDescriptografado, decoder);//Chamando funo dos headers
    rewind (config);//Voltando o ponteiro do arquivo pra utilizar na prxima funo
    fclose ( mapaDescriptografado );//Fechando Mapa descriptografado para nao perder nada do buffer
    mapaDescriptografado = fopen ( "MAPAdescriptografado.TXT", "r");//Abrindo novamente

    inicio = melhor_caminho (mapaDescriptografado, inicio);//Criando lista encadeada e chamando funo dos headers

    desarmar_bomba (bomba, codigo);//Chamando funo dos headers
    rewind (codigo);//Voltando o ponteiro do arquivo pra utilizar na prxima funo

    rewind (bomba);//Voltando o ponteiro do arquivo pra utilizar na prxima funo
    rewind (config);//Voltando o ponteiro do arquivo pra utilizar na prxima funo

    calculos (config, pRobo);//Chamando funo dos headers
    rewind (config);//Voltando o ponteiro do arquivo pra utilizar na prxima funo
    velocidade (config, inicio, pRobo);//Chamando funo dos headers
    rewind (config);//Voltando o ponteiro do arquivo pra utilizar na prxima funo

    criarLog (log, inicio, pRobo);//Chamando funo dos headers
    fclose (log);//Fechando arquivo log para no perder nada do buffer

    printf ("The bomb has been disarmed!");

    //Fechando arquivos
    fclose (mapaCriptografado);
    fclose (mapaDescriptografado);
    fclose (config);
    fclose (bombaDesarmada);
    fclose (bomba);
    fclose (codigo);


    return 0;
}
